<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>learn-md</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <p>
      Markdown also varies in implementation from one parser to a next. This
      guide will attempt to clarify when features are universal or when they are
      specific to a certain parser.
    </p>
    <ul>
      <li><a href="#html-elements">HTML Elements</a></li>
      <li><a href="#headings">Headings</a></li>
      <li><a href="#simple-text-styles">Simple Text Styles</a></li>
      <li><a href="#paragraphs">Paragraphs</a></li>
      <li><a href="#lists">Lists</a></li>
      <li><a href="#code-blocks">Code blocks</a></li>
      <li><a href="#horizontal-rule">Horizontal rule</a></li>
      <li><a href="#links">Links</a></li>
      <li><a href="#images">Images</a></li>
      <li><a href="#miscellany">Miscellany</a></li>
    </ul>
    <h2 id="html-elements">HTML Elements</h2>
    <p>Markdown is a superset of HTML, so any HTML file is valid Markdown.</p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb1-1" title="1">&lt;!--<span class="co">This means we can use HTML elements in Markdown, such as the comment </span></a>
<a class="sourceLine" id="cb1-2" title="2"><span class="co">element, and they won&#39;t be affected by a markdown parser. However, if you </span></a>
<a class="sourceLine" id="cb1-3" title="3"><span class="co">create an HTML element in your markdown file, you cannot use markdown syntax </span></a>
<a class="sourceLine" id="cb1-4" title="4"><span class="co">within that element&#39;s contents.--&gt;</span></a></code></pre>
    </div>
    <h2 id="headings">Headings</h2>
    <p>
      You can create HTML elements <code>&lt;h1&gt;</code> through
      <code>&lt;h6&gt;</code> easily by prepending the text you want to be in
      that element by a number of hashes (#).
    </p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb2-1" title="1"><span class="fu"># This is an &lt;h1&gt;</span></a>
<a class="sourceLine" id="cb2-2" title="2"><span class="fu">## This is an &lt;h2&gt;</span></a>
<a class="sourceLine" id="cb2-3" title="3"><span class="fu">### This is an &lt;h3&gt;</span></a>
<a class="sourceLine" id="cb2-4" title="4"><span class="fu">#### This is an &lt;h4&gt;</span></a>
<a class="sourceLine" id="cb2-5" title="5"><span class="fu">##### This is an &lt;h5&gt;</span></a>
<a class="sourceLine" id="cb2-6" title="6"><span class="fu">###### This is an &lt;h6&gt;</span></a></code></pre>
    </div>
    <p>
      Markdown also provides us with two alternative ways of indicating h1 and
      h2.
    </p>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb3-1" title="1">This is an h1</a>
<a class="sourceLine" id="cb3-2" title="2">=============</a>
<a class="sourceLine" id="cb3-3" title="3"></a>
<a class="sourceLine" id="cb3-4" title="4">This is an h2</a>
<a class="sourceLine" id="cb3-5" title="5">-------------</a></code></pre>
    </div>
    <h2 id="simple-text-styles">Simple text styles</h2>
    <p>Text can be easily styled as italic or bold using markdown.</p>
    <div class="sourceCode" id="cb4">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb4-1" title="1">*This text is in italics.*</a>
<a class="sourceLine" id="cb4-2" title="2">_And so is this text._</a>
<a class="sourceLine" id="cb4-3" title="3"></a>
<a class="sourceLine" id="cb4-4" title="4">**This text is in bold.**</a>
<a class="sourceLine" id="cb4-5" title="5">__And so is this text.__</a>
<a class="sourceLine" id="cb4-6" title="6"></a>
<a class="sourceLine" id="cb4-7" title="7">***This text is in both.***</a>
<a class="sourceLine" id="cb4-8" title="8">**_As is this!_**</a>
<a class="sourceLine" id="cb4-9" title="9">*__And this!__*</a></code></pre>
    </div>
    <p>
      In GitHub Flavored Markdown, which is used to render markdown files on
      GitHub, we also have strikethrough:
    </p>
    <div class="sourceCode" id="cb5">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb5-1" title="1">~~This text is rendered with strikethrough.~~</a></code></pre>
    </div>
    <h2 id="paragraphs">Paragraphs</h2>
    <p>
      Paragraphs are a one or multiple adjacent lines of text separated by one
      or multiple blank lines.
    </p>
    <div class="sourceCode" id="cb6">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb6-1" title="1">This is a paragraph. I&#39;m typing in a paragraph isn&#39;t this fun?</a>
<a class="sourceLine" id="cb6-2" title="2"></a>
<a class="sourceLine" id="cb6-3" title="3">Now I&#39;m in paragraph 2.</a>
<a class="sourceLine" id="cb6-4" title="4">I&#39;m still in paragraph 2 too!</a>
<a class="sourceLine" id="cb6-5" title="5"></a>
<a class="sourceLine" id="cb6-6" title="6"></a>
<a class="sourceLine" id="cb6-7" title="7">I&#39;m in paragraph three!</a></code></pre>
    </div>
    <p>
      Should you ever want to insert an HTML <code>&lt;br /&gt;</code> tag, you
      can end a paragraph with two or more spaces and then begin a new
      paragraph.
    </p>
    <div class="sourceCode" id="cb7">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb7-1" title="1">I end with two spaces (highlight me to see them).</a>
<a class="sourceLine" id="cb7-2" title="2"></a>
<a class="sourceLine" id="cb7-3" title="3">There&#39;s a &lt;br /&gt; above me!</a></code></pre>
    </div>
    <p>Block quotes are easy and done with the &gt; character.</p>
    <div class="sourceCode" id="cb8">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb8-1" title="1">&gt;<span class="dt"> This is a block quote. You can either</span></a>
<a class="sourceLine" id="cb8-2" title="2"><span class="dt">&gt; manually wrap your lines and put a </span><span class="bn">`&gt;`</span><span class="dt"> before every line or you can let your lines get really long and wrap on their own.</span></a>
<a class="sourceLine" id="cb8-3" title="3"><span class="dt">&gt; It doesn&#39;t make a difference so long as they start with a </span><span class="bn">`&gt;`</span><span class="dt">.</span></a>
<a class="sourceLine" id="cb8-4" title="4"></a>
<a class="sourceLine" id="cb8-5" title="5">&gt;<span class="dt"> You can also use more than one level</span></a>
<a class="sourceLine" id="cb8-6" title="6"><span class="dt">&gt;&gt; of indentation?</span></a>
<a class="sourceLine" id="cb8-7" title="7"><span class="dt">&gt; How neat is that?</span></a></code></pre>
    </div>
    <h2 id="lists">Lists</h2>
    <p>Unordered lists can be made using asterisks, pluses, or hyphens.</p>
    <div class="sourceCode" id="cb9">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb9-1" title="1">* <span class="fl">Item</span></a>
<a class="sourceLine" id="cb9-2" title="2"><span class="fl">* Item</span></a>
<a class="sourceLine" id="cb9-3" title="3"><span class="fl">* Another item</span></a>
<a class="sourceLine" id="cb9-4" title="4"></a>
<a class="sourceLine" id="cb9-5" title="5">or</a>
<a class="sourceLine" id="cb9-6" title="6"></a>
<a class="sourceLine" id="cb9-7" title="7">+ <span class="fl">Item</span></a>
<a class="sourceLine" id="cb9-8" title="8"><span class="fl">+ Item</span></a>
<a class="sourceLine" id="cb9-9" title="9"><span class="fl">+ One more item</span></a>
<a class="sourceLine" id="cb9-10" title="10"></a>
<a class="sourceLine" id="cb9-11" title="11">or</a>
<a class="sourceLine" id="cb9-12" title="12"></a>
<a class="sourceLine" id="cb9-13" title="13">- <span class="fl">Item</span></a>
<a class="sourceLine" id="cb9-14" title="14"><span class="fl">- Item</span></a>
<a class="sourceLine" id="cb9-15" title="15"><span class="fl">- One last item</span></a></code></pre>
    </div>
    <p>Ordered lists are done with a number followed by a period.</p>
    <div class="sourceCode" id="cb10">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb10-1" title="1">1. <span class="fl">Item one</span></a>
<a class="sourceLine" id="cb10-2" title="2"><span class="fl">2. Item two</span></a>
<a class="sourceLine" id="cb10-3" title="3"><span class="fl">3. Item three</span></a></code></pre>
    </div>
    <p>
      You don’t even have to label the items correctly and Markdown will still
      render the numbers in order, but this may not be a good idea.
    </p>
    <div class="sourceCode" id="cb11">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb11-1" title="1">1. <span class="fl">Item one</span></a>
<a class="sourceLine" id="cb11-2" title="2"><span class="fl">1. Item two</span></a>
<a class="sourceLine" id="cb11-3" title="3"><span class="fl">1. Item three</span></a></code></pre>
    </div>
    <p>(This renders the same as the above example)</p>
    <p>You can also use sublists</p>
    <div class="sourceCode" id="cb12">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb12-1" title="1">1. <span class="fl">Item one</span></a>
<a class="sourceLine" id="cb12-2" title="2"><span class="fl">2. Item two</span></a>
<a class="sourceLine" id="cb12-3" title="3"><span class="fl">3. Item three</span></a>
<a class="sourceLine" id="cb12-4" title="4"><span class="fl">    * Sub-item</span></a>
<a class="sourceLine" id="cb12-5" title="5"><span class="fl">    * Sub-item</span></a>
<a class="sourceLine" id="cb12-6" title="6"><span class="fl">4. Item four</span></a></code></pre>
    </div>
    <p>There are even task lists. This creates HTML checkboxes.</p>
    <div class="sourceCode" id="cb13">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb13-1" title="1">Boxes below without the &#39;x&#39; are unchecked HTML checkboxes.</a>
<a class="sourceLine" id="cb13-2" title="2">- <span class="fl">[ ] First task to complete.</span></a>
<a class="sourceLine" id="cb13-3" title="3"><span class="fl">- [ ] Second task that needs done</span></a>
<a class="sourceLine" id="cb13-4" title="4"><span class="fl">This checkbox below will be a checked HTML checkbox.</span></a>
<a class="sourceLine" id="cb13-5" title="5"><span class="fl">- [x] This task has been completed</span></a></code></pre>
    </div>
    <h2 id="code-blocks">Code blocks</h2>
    <p>
      You can indicate a code block (which uses the
      <code>&lt;code&gt;</code> element) by indenting a line with four spaces or
      a tab.
    </p>
    <div class="sourceCode" id="cb14">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb14-1" title="1"><span class="bn">    This is code</span></a>
<a class="sourceLine" id="cb14-2" title="2"><span class="bn">    So is this</span></a></code></pre>
    </div>
    <p>
      You can also re-tab (or add an additional four spaces) for indentation
      inside your code
    </p>
    <div class="sourceCode" id="cb15">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb15-1" title="1"><span class="bn">    my_array.each do |item|</span></a>
<a class="sourceLine" id="cb15-2" title="2"><span class="bn">        puts item</span></a>
<a class="sourceLine" id="cb15-3" title="3"><span class="bn">    end</span></a></code></pre>
    </div>
    <p>
      Inline code can be created using the backtick character <code>`</code>
    </p>
    <div class="sourceCode" id="cb16">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb16-1" title="1">John didn&#39;t even know what the <span class="bn">`go_to()`</span> function did!</a></code></pre>
    </div>
    <p>In GitHub Flavored Markdown, you can use a special syntax for code</p>
    <pre>
<code class="highlight">&#x60;&#x60;&#x60;ruby
def foobar
    puts "Hello world!"
end
&#x60;&#x60;&#x60;</code></pre>
    <p>
      The above text doesn’t require indenting, plus GitHub will use syntax
      highlighting of the language you specify after the ```
    </p>
    <h2 id="horizontal-rule">Horizontal rule</h2>
    <p>
      Horizontal rules (<code>&lt;hr/&gt;</code>) are easily added with three or
      more asterisks or hyphens, with or without spaces.
    </p>
    <div class="sourceCode" id="cb17">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb17-1" title="1">***</a>
<a class="sourceLine" id="cb17-2" title="2">---</a>
<a class="sourceLine" id="cb17-3" title="3">- - -</a>
<a class="sourceLine" id="cb17-4" title="4">****************</a></code></pre>
    </div>
    <h2 id="links">Links</h2>
    <p>
      One of the best things about markdown is how easy it is to make links. Put
      the text to display in hard brackets [] followed by the url in parentheses
      ()
    </p>
    <div class="sourceCode" id="cb18">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb18-1" title="1"><span class="ot">[Click me!](http://test.com/)</span></a></code></pre>
    </div>
    <p>You can also add a link title using quotes inside the parentheses.</p>
    <div class="sourceCode" id="cb19">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb19-1" title="1"><span class="ot">[Click me!](http://test.com/ &quot;Link to Test.com&quot;)</span></a></code></pre>
    </div>
    <p>Relative paths work too.</p>
    <div class="sourceCode" id="cb20">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb20-1" title="1"><span class="ot">[Go to music](/music/)</span>.</a></code></pre>
    </div>
    <p>Markdown also supports reference style links.</p>
    <pre><code class="highlight">&#x5b;<span class="nv">Click this link</span>][<span class="ss">link1</span>] for more info about it!
&#x5b;<span class="nv">Also check out this link</span>][<span class="ss">foobar</span>] if you want to.

&#x5b;<span class="nv">link1</span>]: <span class="sx">http://test.com/</span> <span class="nn">"Cool!"</span>
&#x5b;<span class="nv">foobar</span>]: <span class="sx">http://foobar.biz/</span> <span class="nn">"Alright!"</span></code></pre>
    <p>
      The title can also be in single quotes or in parentheses, or omitted
      entirely. The references can be anywhere in your document and the
      reference IDs can be anything so long as they are unique.
    </p>
    <p>
      There is also “implicit naming” which lets you use the link text as the
      id.
    </p>
    <pre><code class="highlight">&#x5b;<span class="nv">This</span>][] is a link.

&#x5b;<span class="nv">this</span>]: <span class="sx">http://thisisalink.com/</span></code></pre>
    <p>But it’s not that commonly used.</p>
    <h2 id="images">Images</h2>
    <p>
      Images are done the same way as links but with an exclamation point in
      front!
    </p>
    <div class="sourceCode" id="cb21">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb21-1" title="1"><span class="al">![This is the alt-attribute for my image](http://imgur.com/myimage.jpg &quot;An optional title&quot;)</span></a></code></pre>
    </div>
    <p>And reference style works as expected.</p>
    <pre><code class="highlight">!&#x5b;<span class="nv">This is the alt-attribute.</span>][<span class="ss">myimage</span>]

&#x5b;<span class="nv">myimage</span>]: <span class="sx">relative/urls/cool/image.jpg</span> <span class="nn">"if you need a title, it's here"</span></code></pre>
    <h2 id="miscellany">Miscellany</h2>
    <h3 id="auto-links">Auto-links</h3>
    <div class="sourceCode" id="cb22">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb22-1" title="1"><span class="ot">&lt;http://testwebsite.com/&gt;</span> is equivalent to</a>
<a class="sourceLine" id="cb22-2" title="2"><span class="ot">[http://testwebsite.com/](http://testwebsite.com/)</span></a></code></pre>
    </div>
    <h3 id="auto-links-for-emails">Auto-links for emails</h3>
    <div class="sourceCode" id="cb23">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb23-1" title="1"><span class="ot">&lt;foo@bar.com&gt;</span></a></code></pre>
    </div>
    <h3 id="escaping-characters">Escaping characters</h3>
    <div class="sourceCode" id="cb24">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb24-1" title="1">I want to type *this text surrounded by asterisks* but I don&#39;t want it to be</a>
<a class="sourceLine" id="cb24-2" title="2">in italics, so I do this: \*this text surrounded by asterisks\*.</a></code></pre>
    </div>
    <h3 id="keyboard-keys">Keyboard keys</h3>
    <p>
      In GitHub Flavored Markdown, you can use a <code>&lt;kbd&gt;</code> tag to
      represent keyboard keys.
    </p>
    <div class="sourceCode" id="cb25">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb25-1" title="1">Your computer crashed? Try sending a</a>
<a class="sourceLine" id="cb25-2" title="2">&lt;kbd&gt;Ctrl&lt;/kbd&gt;+&lt;kbd&gt;Alt&lt;/kbd&gt;+&lt;kbd&gt;Del&lt;/kbd&gt;</a></code></pre>
    </div>
    <h3 id="tables">Tables</h3>
    <p>
      Tables are only available in GitHub Flavored Markdown and are slightly
      cumbersome, but if you really want it:
    </p>
    <div class="sourceCode" id="cb26">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb26-1" title="1">| Col1         | Col2     | Col3          |</a>
<a class="sourceLine" id="cb26-2" title="2">| :----------- | :------: | ------------: |</a>
<a class="sourceLine" id="cb26-3" title="3">| Left-aligned | Centered | Right-aligned |</a>
<a class="sourceLine" id="cb26-4" title="4">| blah         | blah     | blah          |</a></code></pre>
    </div>
    <p>or, for the same results</p>
    <div class="sourceCode" id="cb27">
      <pre
        class="sourceCode md"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb27-1" title="1">Col 1 | Col2 | Col3</a>
<a class="sourceLine" id="cb27-2" title="2">:-- | :-: | --:</a>
<a class="sourceLine" id="cb27-3" title="3">Ugh this is so ugly | make it | stop</a></code></pre>
    </div>
  </body>
</html>
